package com.zksy.web.controller.basicData;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmTransportAdministrativePenalty;
import com.zksy.system.basicData.service.CrmTransportAdministrativePenaltyService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 交通运输-行政处罚Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/crmTransportAdministrativePenalty")
@Api(tags = "交通运输-行政处罚", description = "交通运输-行政处罚desc")
public class CrmTransportAdministrativePenaltyController extends BaseController{

    @Autowired
    private CrmTransportAdministrativePenaltyService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "交通运输-行政处罚搜索getById")
    public CrmTransportAdministrativePenalty getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "交通运输-行政处罚分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "交通运输-行政处罚查询所有")
    public List<CrmTransportAdministrativePenalty> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增交通运输-行政处罚
     */
    @PostMapping("/save")
    @ApiOperation(value = "交通运输-行政处罚新增")
    @Log(title = "新增交通运输-行政处罚", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmTransportAdministrativePenalty crmTransportAdministrativePenalty) {
        return service.save(crmTransportAdministrativePenalty);
    }

    /**
     * 修改交通运输-行政处罚
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "交通运输-行政处罚修改")
    @Log(title = "修改交通运输-行政处罚", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmTransportAdministrativePenalty crmTransportAdministrativePenalty) {
        return service.updateById(crmTransportAdministrativePenalty);
    }

    /**
     * 导入交通运输-行政处罚
     */
    @ApiOperation("交通运输-行政处罚导入")
    @Log(title = "交通运输-行政处罚", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmTransportAdministrativePenalty> crmTransportAdministrativePenaltyAll = service.list();
            List<CrmTransportAdministrativePenalty> list = ExcelUtils.readMultipartFile(file, CrmTransportAdministrativePenalty.class,CrmTransportAdministrativePenalty.class.getDeclaredFields().length - 2);
            if(crmTransportAdministrativePenaltyAll != null && crmTransportAdministrativePenaltyAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("交通运输-行政处罚导出")
    @Log(title = "交通运输-行政处罚", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmTransportAdministrativePenalty> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"交通运输-行政处罚",wrapperList,CrmTransportAdministrativePenalty.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "交通运输-行政处罚", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除交通运输-行政处罚", notes = "删除交通运输-行政处罚")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"交通运输-行政处罚模板");
    }
}

